using System.Text.Json;
using System.Text.Json.Serialization;

namespace View_by_Distance.Shared.Models;

public class MappingFromFilter : Properties.IMappingFromFilter
{

    public bool? IsFocusModel { init; get; }
    public bool? IsFocusPerson { init; get; }
    public bool? IsFocusRelativePath { init; get; }
    public bool? IsIgnoreRelativePath { init; get; }
    public bool? InSkipCollection { init; get; }
    public bool? IsUsed { init; get; }

    [JsonConstructor]
    public MappingFromFilter(bool? isFocusModel, bool? isFocusPerson, bool? isFocusRelativePath, bool? isIgnoreRelativePath, bool? inSkipCollection, bool? isUsed)
    {
        IsFocusModel = isFocusModel;
        IsFocusPerson = isFocusPerson;
        IsFocusRelativePath = isFocusRelativePath;
        IsIgnoreRelativePath = isIgnoreRelativePath;
        InSkipCollection = inSkipCollection;
        IsUsed = isUsed;
    }

    public override string ToString()
    {
        string result = JsonSerializer.Serialize(this, new JsonSerializerOptions() { WriteIndented = true });
        return result;
    }

}