namespace View_by_Distance.Shared.Models.Stateless.Methods;

public interface IPerson
{

    // ...

    Models.PersonName TestStatic_GetPersonName(string name) =>
        GetPersonName(name);
    static Models.PersonName GetPersonName(string name) =>
       PersonName.GetPersonName(name);

    static (char, char, char) GetPersonHour(string personDisplayDirectoryName, int hour) =>
        hour == 0 ? new('U', 'U', 'U') :
        hour == 1 ? new('U', 'U', 'U') :
        hour == 2 ? new('U', 'U', 'U') :
        hour == 3 ? new('A', 'U', 'Y') :
        hour == 4 ? new('A', 'F', 'Y') :
        hour == 5 ? new('A', 'M', 'Y') :
        hour == 6 ? new('A', 'F', 'N') :
        hour == 7 ? new('A', 'M', 'N') :
        hour == 13 ? new('D', 'U', 'Y') :
        hour == 14 ? new('D', 'F', 'Y') :
        hour == 15 ? new('D', 'M', 'Y') :
        hour == 16 ? new('D', 'F', 'N') :
        hour == 17 ? new('D', 'M', 'N') :
        throw new NotImplementedException(personDisplayDirectoryName);

    static string GetHourGroup(string personDisplayDirectoryName, int hour) =>
        hour == 0 ? "Unknown-Unknown-Unknown" :
        hour == 1 ? "Unknown-Unknown-Unknown" :
        hour == 2 ? "Unknown-Unknown-Unknown" :
        hour == 3 ? "Alive-Unknown-Yes" :
        hour == 4 ? "Alive-Female-Yes" :
        hour == 5 ? "Alive-Male-Yes" :
        hour == 6 ? "Alive-Female-No" :
        hour == 7 ? "Alive-Male-No" :
        hour == 13 ? "Dead-Unknown-Yes" :
        hour == 14 ? "Dead-Female-Yes" :
        hour == 15 ? "Dead-Male-Yes" :
        hour == 16 ? "Dead-Female-No" :
        hour == 17 ? "Dead-Male-No" :
        throw new NotImplementedException(personDisplayDirectoryName);

    bool TestStatic_IsDefaultName(string mappingDefaultName, string value) =>
        IsDefaultName(mappingDefaultName, value);
    static bool IsDefaultName(string mappingDefaultName, string value) =>
        value == mappingDefaultName || (value.Length > 1 && value[0] == 'X' && value[1] == ']');

    bool TestStatic_IsDefaultName(string mappingDefaultName, Models.Person person) =>
        IsDefaultName(mappingDefaultName, person);
    static bool IsDefaultName(string mappingDefaultName, Models.Person person) =>
        IsDefaultName(mappingDefaultName, person.Name.Alias is null ? string.Empty : person.Name.Alias.Value);

    string TestStatic_GetFileFullName(Properties.IStorage storage, string personBirthdayFormat, Models.Person person) =>
        GetFileFullName(storage, personBirthdayFormat, person);
    static string GetFileFullName(Properties.IStorage storage, string personBirthdayFormat, Models.Person person) =>
        IPersonBirthday.GetFileFullName(storage, personBirthdayFormat, person.Birthday);

    Models.Person TestStatic_GetPerson(char[] personCharacters, string personDisplayDirectoryName, long personKey, Models.PersonBirthday personBirthday) =>
        GetPerson(personCharacters, personDisplayDirectoryName, personKey, personBirthday);
    static Models.Person GetPerson(char[] personCharacters, string personDisplayDirectoryName, long personKey, Models.PersonBirthday personBirthday) =>
        Person.GetPerson(personCharacters, personDisplayDirectoryName, Array.Empty<string>(), personKey, personBirthday);

    Models.Person TestStatic_GetPerson(char[] personCharacters, string personDisplayDirectoryName, string[] personDisplayDirectoryAllFiles, long personKey) =>
        GetPerson(personCharacters, personDisplayDirectoryName, personDisplayDirectoryAllFiles, personKey);
    static Models.Person GetPerson(char[] personCharacters, string personDisplayDirectoryName, string[] personDisplayDirectoryAllFiles, long personKey) =>
        Person.GetPerson(personCharacters, personDisplayDirectoryName, personDisplayDirectoryAllFiles, personKey, IPersonBirthday.GetPersonBirthday(personKey));

}